#include <LiquidCrystal.h>
const int rs = 12, en = 11, d4 = 10, d5 = 9, d6 = 8, d7 = 7;
LiquidCrystal lcd(12, 11, 10, 9, 8, 7);
const int buzPin = 4;
const int trigPin = 6;
const int echoPin = 5;
bool close = false;
int check_dist = 0;
long duration;
int distance;
unsigned long previousMillis = 0;
void setup() {
  lcd.begin(16, 2);
  pinMode(buzPin, OUTPUT);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  lcd.setCursor(0, 0);
  lcd.print("Hello World!");
  delay(1000);
  lcd.clear();
  Serial.begin(9600);
}

void loop() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  unsigned long currentMillis = millis();
  distance = duration * 0.034/2;
  if (distance <= 20 && close == false){
    close = true;
    check_dist = 20;
    noTone(buzPin);
  }
  else if ((distance > check_dist && close == true) && check_dist == 20){
    close = false;
    check_dist = 0;
    if (currentMillis - previousMillis >= 500)
    {
    tone(buzPin, 700);
    delay(1000);
    previousMillis = currentMillis;
    }
    noTone(buzPin);
  }
  lcd.setCursor(0, 0);
  lcd.print("Distance:");
  Serial.println(distance);
  delay(1000);
  lcd.setCursor(9, 0);
  lcd.print(distance);
  delay(1000);
  lcd.setCursor(12, 0);
  lcd.print("cm");
 

}
